package nc.bs.gl.DataAdjust;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;
import javax.naming.NamingException;
import nc.bs.logging.Logger;
import nc.bs.pub.DataManageObject;
import nc.vo.glcom.ass.AdjustAssVO;

public class UnifyFreevalueData extends DataManageObject {

   String checkType;
   String[] checkValues;


   public UnifyFreevalueData() throws NamingException {
   }

   public void unify() {
      Connection con = null;
      PreparedStatement stmt = null;

      try {
         con = this.getConnection();
         Hashtable e = new Hashtable();
         Hashtable hmDelid = new Hashtable();

         String delSql;
         for(int it = 0; this.checkValues != null && it < this.checkValues.length; ++it) {
            delSql = "select distinct (freevalueid), checkcount from gl_freevalue where checktype = \'" + this.checkType + "\' and checkvalue = \'" + this.checkValues[it] + "\'";
            stmt = con.prepareStatement(delSql);
            ResultSet updateSql = stmt.executeQuery();
            ArrayList updateVerifySql = new ArrayList();
            AdjustAssVO aavo = null;

            while(updateSql.next()) {
               aavo = new AdjustAssVO();
               aavo.setFreevalueid(updateSql.getString(1));
               aavo.setCheckcount(updateSql.getInt(2));
               updateVerifySql.add(aavo);
            }

            for(int j = 0; updateVerifySql != null && j < updateVerifySql.size(); ++j) {
               if(e.get(((AdjustAssVO)updateVerifySql.get(it)).getFreevalueid()) == null) {
                  String delDataSql = "select distinct (freevalueid) from gl_freevalue where (checktype, checkvalue) in ( select checktype, checkvalue from gl_freevalue where freevalueid = \'" + ((AdjustAssVO)updateVerifySql.get(it)).getFreevalueid() + "\') and checkcount = " + ((AdjustAssVO)updateVerifySql.get(it)).getCheckcount() + " and freevalueid <> \'" + ((AdjustAssVO)updateVerifySql.get(it)).getFreevalueid() + "\' group by freevalueid having count (*) = " + ((AdjustAssVO)updateVerifySql.get(it)).getCheckcount() + "";
                  stmt = con.prepareStatement(delDataSql);
                  updateSql = stmt.executeQuery();
                  StringBuffer delid = new StringBuffer();

                  while(updateSql.next()) {
                     e.put(updateSql.getString(1), updateSql.getString(1));
                     delid.append("\'" + updateSql.getString(1) + "\',");
                  }

                  if(delid.length() > 0) {
                     delid = delid.deleteCharAt(delid.length() - 1);
                     hmDelid.put(((AdjustAssVO)updateVerifySql.get(it)).getFreevalueid(), delid.toString());
                  }
               }
            }
         }

         Iterator var14 = hmDelid.entrySet().iterator();
         delSql = "delete from gl_freevalue where freevalueid = ?";
         stmt = con.prepareStatement(delSql);
         if(var14.hasNext()) {
            stmt.setString(1, (String)hmDelid.get(var14.next().toString()));
            stmt.addBatch();
         }

         stmt.executeBatch();
         String var15 = "update gl_detail set assid = ? where assid = ?";
         stmt = con.prepareStatement(var15);
         var14 = hmDelid.entrySet().iterator();
         if(var14.hasNext()) {
            stmt.setString(1, var14.next().toString());
            stmt.setString(2, (String)hmDelid.get(var14.next().toString()));
            stmt.addBatch();
         }

         stmt.executeBatch();
         String var16 = "update gl_verifydetail set assid = ? where assid = ? ";
         stmt = con.prepareStatement(var16);
         var14 = hmDelid.entrySet().iterator();
         if(var14.hasNext()) {
            stmt.setString(1, var14.next().toString());
            stmt.setString(2, (String)hmDelid.get(var14.next().toString()));
            stmt.addBatch();
         }

         stmt.executeBatch();
      } catch (SQLException var13) {
         Logger.error(var13.getMessage(), var13);
      }

   }

   public static void main(String[] args) {
      try {
         UnifyFreevalueData uf = new UnifyFreevalueData();
         uf.unify();
      } catch (NamingException var3) {
         var3.printStackTrace();
      }

   }

   public String getCheckType() {
      return this.checkType;
   }

   public void setCheckType(String checkType) {
      this.checkType = checkType;
   }

   public String[] getCheckValues() {
      return this.checkValues;
   }

   public void setCheckValues(String[] checkValues) {
      this.checkValues = checkValues;
   }
}
